# Class VulkanShaderModuleCreateInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanShaderModuleCreateInfo.Builder

Enclosing class:
  `VulkanShaderModuleCreateInfo`

public static final class VulkanShaderModuleCreateInfo.Builder extends Object
Builds instances of type `VulkanShaderModuleCreateInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanShaderModuleCreateInfo.Builder`
  `addAllFlags(Iterable<VulkanShaderModuleCreateFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanShaderModuleCreateInfo.Builder`
  `addFlags(VulkanShaderModuleCreateFlag element)`
  Adds one element to `flags` set.
  `final VulkanShaderModuleCreateInfo.Builder`
  `addFlags(VulkanShaderModuleCreateFlag... elements)`
  Adds elements to `flags` set.
  `VulkanShaderModuleCreateInfo`
  `build()`
  Builds a new `VulkanShaderModuleCreateInfo`.
  `final VulkanShaderModuleCreateInfo.Builder`
  `from(VulkanShaderModuleCreateInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanShaderModuleCreateInfoType` instance.
  `final VulkanShaderModuleCreateInfo.Builder`
  `setData(ByteBuffer data)`
  Initializes the value for the `data` attribute.
  `final VulkanShaderModuleCreateInfo.Builder`
  `setFlags(Iterable<VulkanShaderModuleCreateFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanShaderModuleCreateInfo.Builder`
  `setSize(long size)`
  Initializes the value for the `size` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanShaderModuleCreateInfo.Builder from(VulkanShaderModuleCreateInfoType instance)
    Fill a builder with attribute values from the provided `VulkanShaderModuleCreateInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanShaderModuleCreateInfo.Builder addFlags(VulkanShaderModuleCreateFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanShaderModuleCreateInfo.Builder addFlags(VulkanShaderModuleCreateFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanShaderModuleCreateInfo.Builder setFlags(Iterable<VulkanShaderModuleCreateFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanShaderModuleCreateInfo.Builder addAllFlags(Iterable<VulkanShaderModuleCreateFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setData

    public final VulkanShaderModuleCreateInfo.Builder setData(ByteBuffer data)
    Initializes the value for the `data` attribute.
    Parameters:
      `data` - The value for data
    Returns:
      `this` builder for use in a chained invocation

  - ### setSize

    public final VulkanShaderModuleCreateInfo.Builder setSize(long size)
    Initializes the value for the `size` attribute.
    Parameters:
      `size` - The value for size
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanShaderModuleCreateInfo build()
    Builds a new `VulkanShaderModuleCreateInfo`.
    Returns:
      An immutable instance of VulkanShaderModuleCreateInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing